diff --git a/strongswan-5.2.0/src/libstrongswan/Makefile.am b/strongswan-5.2.0/src/libstrongswan/Makefile.am
index 3fb57de..63d208f 100644
--- a/strongswan-5.2.0/src/libstrongswan/Makefile.am
+++ b/strongswan-5.2.0/src/libstrongswan/Makefile.am
@@ -10,7 +10,7 @@ crypto/proposal/proposal_keywords.c crypto/proposal/proposal_keywords_static.c \
 crypto/prfs/prf.c crypto/prfs/mac_prf.c crypto/pkcs5.c \
 crypto/rngs/rng.c crypto/prf_plus.c crypto/signers/signer.c \
 crypto/signers/mac_signer.c crypto/crypto_factory.c crypto/crypto_tester.c \
-crypto/diffie_hellman.c crypto/aead.c crypto/transform.c \
+crypto/diffie_hellman.c crypto/aead.c crypto/key_transformer.c crypto/transform.c \
 crypto/iv/iv_gen_rand.c crypto/iv/iv_gen_seq.c \
 credentials/credential_factory.c credentials/builder.c \
 credentials/cred_encoding.c credentials/keys/private_key.c \
@@ -65,8 +65,8 @@ crypto/proposal/proposal_keywords.h crypto/proposal/proposal_keywords_static.h \
 crypto/prfs/prf.h crypto/prfs/mac_prf.h crypto/rngs/rng.h crypto/nonce_gen.h \
 crypto/prf_plus.h crypto/signers/signer.h crypto/signers/mac_signer.h \
 crypto/crypto_factory.h crypto/crypto_tester.h crypto/diffie_hellman.h \
-crypto/aead.h crypto/transform.h crypto/pkcs5.h crypto/iv/iv_gen.h \
-crypto/iv/iv_gen_rand.h crypto/iv/iv_gen_seq.h \
+crypto/aead.h crypto/key_transformer.h crypto/transform.h crypto/pkcs5.h \
+crypto/iv/iv_gen.h crypto/iv/iv_gen_rand.h crypto/iv/iv_gen_seq.h \
 credentials/credential_factory.h credentials/builder.h \
 credentials/cred_encoding.h credentials/keys/private_key.h \
 credentials/keys/public_key.h credentials/keys/shared_key.h \
@@ -179,8 +179,7 @@ endif
 
 EXTRA_DIST = \
 asn1/oid.txt asn1/oid.pl \
-crypto/proposal/proposal_keywords_static.txt \
-Android.mk AndroidConfigLocal.h
+crypto/proposal/proposal_keywords_static.txt
 
 BUILT_SOURCES = \
 $(srcdir)/asn1/oid.c $(srcdir)/asn1/oid.h \
@@ -215,13 +214,6 @@ else
 SUBDIRS = .
 endif
 
-if USE_AF_ALG
-  SUBDIRS += plugins/af_alg
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/af_alg/libstrongswan-af-alg.la
-endif
-endif
-
 if USE_AES
   SUBDIRS += plugins/aes
 if MONOLITHIC
@@ -229,38 +221,24 @@ if MONOLITHIC
 endif
 endif
 
-if USE_DES
-  SUBDIRS += plugins/des
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/des/libstrongswan-des.la
-endif
-endif
-
-if USE_BLOWFISH
-  SUBDIRS += plugins/blowfish
+if USE_CONTACTCRYPTO
+  SUBDIRS += plugins/contactcrypto
 if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/blowfish/libstrongswan-blowfish.la
+  libstrongswan_la_LIBADD += plugins/contactcrypto/libstrongswan-des.la
 endif
 endif
 
-if USE_RC2
-  SUBDIRS += plugins/rc2
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/rc2/libstrongswan-rc2.la
-endif
-endif
-
-if USE_MD4
-  SUBDIRS += plugins/md4
+if USE_GMP
+  SUBDIRS += plugins/gmp
 if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/md4/libstrongswan-md4.la
+  libstrongswan_la_LIBADD += plugins/gmp/libstrongswan-gmp.la
 endif
 endif
 
-if USE_MD5
-  SUBDIRS += plugins/md5
+if USE_USBBAR
+  SUBDIRS += plugins/usbbar
 if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/md5/libstrongswan-md5.la
+  libstrongswan_la_LIBADD += plugins/usbbar/libstrongswan-usbbar.la
 endif
 endif
 
@@ -271,27 +249,6 @@ if MONOLITHIC
 endif
 endif
 
-if USE_SHA2
-  SUBDIRS += plugins/sha2
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/sha2/libstrongswan-sha2.la
-endif
-endif
-
-if USE_GMP
-  SUBDIRS += plugins/gmp
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/gmp/libstrongswan-gmp.la
-endif
-endif
-
-if USE_RDRAND
-  SUBDIRS += plugins/rdrand
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/rdrand/libstrongswan-rdrand.la
-endif
-endif
-
 if USE_RANDOM
   SUBDIRS += plugins/random
 if MONOLITHIC
@@ -313,20 +270,6 @@ if MONOLITHIC
 endif
 endif
 
-if USE_CMAC
-  SUBDIRS += plugins/cmac
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/cmac/libstrongswan-cmac.la
-endif
-endif
-
-if USE_XCBC
-  SUBDIRS += plugins/xcbc
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/xcbc/libstrongswan-xcbc.la
-endif
-endif
-
 if USE_X509
   SUBDIRS += plugins/x509
 if MONOLITHIC
@@ -348,13 +291,6 @@ if MONOLITHIC
 endif
 endif
 
-if USE_ACERT
-  SUBDIRS += plugins/acert
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/acert/libstrongswan-acert.la
-endif
-endif
-
 if USE_PUBKEY
   SUBDIRS += plugins/pubkey
 if MONOLITHIC
@@ -362,55 +298,6 @@ if MONOLITHIC
 endif
 endif
 
-if USE_PKCS1
-  SUBDIRS += plugins/pkcs1
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/pkcs1/libstrongswan-pkcs1.la
-endif
-endif
-
-if USE_PKCS7
-  SUBDIRS += plugins/pkcs7
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/pkcs7/libstrongswan-pkcs7.la
-endif
-endif
-
-if USE_PKCS8
-  SUBDIRS += plugins/pkcs8
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/pkcs8/libstrongswan-pkcs8.la
-endif
-endif
-
-if USE_PKCS12
-  SUBDIRS += plugins/pkcs12
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/pkcs12/libstrongswan-pkcs12.la
-endif
-endif
-
-if USE_PGP
-  SUBDIRS += plugins/pgp
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/pgp/libstrongswan-pgp.la
-endif
-endif
-
-if USE_DNSKEY
-  SUBDIRS += plugins/dnskey
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/dnskey/libstrongswan-dnskey.la
-endif
-endif
-
-if USE_SSHKEY
-  SUBDIRS += plugins/sshkey
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/sshkey/libstrongswan-sshkey.la
-endif
-endif
-
 if USE_PEM
   SUBDIRS += plugins/pem
 if MONOLITHIC
@@ -418,139 +305,6 @@ if MONOLITHIC
 endif
 endif
 
-if USE_CURL
-  SUBDIRS += plugins/curl
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/curl/libstrongswan-curl.la
-endif
-endif
-
-if USE_WINHTTP
-  SUBDIRS += plugins/winhttp
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/winhttp/libstrongswan-winhttp.la
-endif
-endif
-
-if USE_UNBOUND
-  SUBDIRS += plugins/unbound
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/unbound/libstrongswan-unbound.la
-endif
-endif
-
-if USE_SOUP
-  SUBDIRS += plugins/soup
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/soup/libstrongswan-soup.la
-endif
-endif
-
-if USE_LDAP
-  SUBDIRS += plugins/ldap
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/ldap/libstrongswan-ldap.la
-endif
-endif
-
-if USE_MYSQL
-  SUBDIRS += plugins/mysql
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/mysql/libstrongswan-mysql.la
-endif
-endif
-
-if USE_SQLITE
-  SUBDIRS += plugins/sqlite
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/sqlite/libstrongswan-sqlite.la
-endif
-endif
-
-if USE_PADLOCK
-  SUBDIRS += plugins/padlock
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/padlock/libstrongswan-padlock.la
-endif
-endif
-
-if USE_OPENSSL
-  SUBDIRS += plugins/openssl
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/openssl/libstrongswan-openssl.la
-endif
-endif
-
-if USE_GCRYPT
-  SUBDIRS += plugins/gcrypt
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/gcrypt/libstrongswan-gcrypt.la
-endif
-endif
-
-if USE_FIPS_PRF
-  SUBDIRS += plugins/fips_prf
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/fips_prf/libstrongswan-fips-prf.la
-endif
-endif
-
-if USE_AGENT
-  SUBDIRS += plugins/agent
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/agent/libstrongswan-agent.la
-endif
-endif
-
-if USE_KEYCHAIN
-  SUBDIRS += plugins/keychain
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/keychain/libstrongswan-keychain.la
-endif
-endif
-
-if USE_PKCS11
-  SUBDIRS += plugins/pkcs11
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/pkcs11/libstrongswan-pkcs11.la
-endif
-endif
-
-if USE_CTR
-  SUBDIRS += plugins/ctr
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/ctr/libstrongswan-ctr.la
-endif
-endif
-
-if USE_CCM
-  SUBDIRS += plugins/ccm
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/ccm/libstrongswan-ccm.la
-endif
-endif
-
-if USE_GCM
-  SUBDIRS += plugins/gcm
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/gcm/libstrongswan-gcm.la
-endif
-endif
-
-if USE_NTRU
-  SUBDIRS += plugins/ntru
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/ntru/libstrongswan-ntru.la
-endif
-endif
-
-if USE_TEST_VECTORS
-  SUBDIRS += plugins/test_vectors
-if MONOLITHIC
-  libstrongswan_la_LIBADD += plugins/test_vectors/libstrongswan-test-vectors.la
-endif
-endif
-
 if MONOLITHIC
   SUBDIRS += .
 endif
diff --git a/strongswan-5.2.0/src/libstrongswan/credentials/builder.c b/strongswan-5.2.0/src/libstrongswan/credentials/builder.c
index ddb64ef..78ce3d9 100644
--- a/strongswan-5.2.0/src/libstrongswan/credentials/builder.c
+++ b/strongswan-5.2.0/src/libstrongswan/credentials/builder.c
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "builder.h"
 
@@ -70,5 +92,8 @@ ENUM(builder_part_names, BUILD_FROM_FILE, BUILD_END,
 	"BUILD_SAFE_PRIMES",
 	"BUILD_SHARES",
 	"BUILD_THRESHOLD",
+	"BUILD_USBBAR_PASS",
+	"BUILD_BLOB_STB1176_KEY",
+	"BUILD_PUB_FROM_PRIV",
 	"BUILD_END",
 );
diff --git a/strongswan-5.2.0/src/libstrongswan/credentials/builder.h b/strongswan-5.2.0/src/libstrongswan/credentials/builder.h
index 627e093..6af027a 100644
--- a/strongswan-5.2.0/src/libstrongswan/credentials/builder.h
+++ b/strongswan-5.2.0/src/libstrongswan/credentials/builder.h
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup builder builder
@@ -151,6 +173,12 @@ enum builder_part_t {
 	BUILD_SHARES,
 	/** minimum number of participating private key shares */
 	BUILD_THRESHOLD,
+	/** usb barrier wraped password file path */
+	BUILD_USBBAR_PASS,
+	/** */
+	BUILD_BLOB_CONTACT_KEY,
+	/** */ 
+	BUILD_PUB_FROM_PRIV,
 	/** end of variable argument builder list */
 	BUILD_END,
 };
diff --git a/strongswan-5.2.0/src/libstrongswan/credentials/cred_encoding.h b/strongswan-5.2.0/src/libstrongswan/credentials/cred_encoding.h
index a6c9c30..6d16c3e 100644
--- a/strongswan-5.2.0/src/libstrongswan/credentials/cred_encoding.h
+++ b/strongswan-5.2.0/src/libstrongswan/credentials/cred_encoding.h
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup cred_encoding cred_encoding
@@ -71,6 +93,8 @@ enum cred_encoding_type_t {
 	KEYID_PGPV3,
 	/** PGPv4 fingerprint */
 	KEYID_PGPV4,
+	/** BELT fingerprint over subjectPublicKey */
+	KEYID_PUBKEY_BELT,
 
 	KEYID_MAX,
 
@@ -98,6 +122,11 @@ enum cred_encoding_type_t {
 	CERT_PEM,
 	/** PGP Packet encoded certificate */
 	CERT_PGP_PKT,
+	
+	/** BIGN subjectPublicKeyInfo encoding */
+	PUBKEY_SPKI_BIGN_ASN1_DER,
+	/** subjectPublicKey encoding */
+	PUBKEY_SPK_ASN1_DER,
 
 	CRED_ENCODING_MAX,
 };
@@ -144,6 +173,8 @@ enum cred_encoding_part_t {
 	CRED_PART_PKCS10_ASN1_DER,
 	/** a PGP encoded certificate */
 	CRED_PART_PGP_CERT,
+	/** a raw key value */
+	CRED_PART_RAW_KEY,
 
 	CRED_PART_END,
 };
diff --git a/strongswan-5.2.0/src/libstrongswan/credentials/keys/public_key.c b/strongswan-5.2.0/src/libstrongswan/credentials/keys/public_key.c
index 37bba77..656cc51 100644
--- a/strongswan-5.2.0/src/libstrongswan/credentials/keys/public_key.c
+++ b/strongswan-5.2.0/src/libstrongswan/credentials/keys/public_key.c
@@ -12,19 +12,43 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  */
+ 
 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
+ 
 #include <asn1/oid.h>
 
 #include "public_key.h"
 
-ENUM(key_type_names, KEY_ANY, KEY_DSA,
+ENUM(key_type_names, KEY_ANY, KEY_BIGN,
 	"ANY",
 	"RSA",
 	"ECDSA",
-	"DSA"
+	"DSA",
+	"BIGN",
 );
 
-ENUM(signature_scheme_names, SIGN_UNKNOWN, SIGN_ECDSA_521,
+ENUM(signature_scheme_names, SIGN_UNKNOWN, SIGN_BIGN_WITH_HBELT,
 	"UNKNOWN",
 	"RSA_EMSA_PKCS1_NULL",
 	"RSA_EMSA_PKCS1_MD5",
@@ -41,6 +65,7 @@ ENUM(signature_scheme_names, SIGN_UNKNOWN, SIGN_ECDSA_521,
 	"ECDSA-256",
 	"ECDSA-384",
 	"ECDSA-521",
+	"BIGN_WITH_HBELT",
 );
 
 ENUM(encryption_scheme_names, ENCRYPT_UNKNOWN, ENCRYPT_RSA_OAEP_SHA512,
@@ -130,8 +155,11 @@ signature_scheme_t signature_scheme_from_oid(int oid)
 			return SIGN_ECDSA_WITH_SHA384_DER;
 		case OID_ECDSA_WITH_SHA512:
 			return SIGN_ECDSA_WITH_SHA512_DER;
+		case OID_HASH_BELT:
+			return SIGN_BIGN_WITH_HBELT;
 		default:
 			return SIGN_UNKNOWN;
+
 	}
 }
 
diff --git a/strongswan-5.2.0/src/libstrongswan/credentials/keys/public_key.h b/strongswan-5.2.0/src/libstrongswan/credentials/keys/public_key.h
index 2afcf83..98d4a8d 100644
--- a/strongswan-5.2.0/src/libstrongswan/credentials/keys/public_key.h
+++ b/strongswan-5.2.0/src/libstrongswan/credentials/keys/public_key.h
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup public_key public_key
@@ -42,7 +64,8 @@ enum key_type_t {
 	KEY_ECDSA = 2,
 	/** DSA */
 	KEY_DSA   = 3,
-	/** ElGamal, ... */
+	/** BIGN pub key */
+	KEY_BIGN = 4,
 };
 
 /**
@@ -90,6 +113,8 @@ enum signature_scheme_t {
 	SIGN_ECDSA_384,
 	/** ECDSA on the P-521 curve with SHA-512 as in RFC 4754           */
 	SIGN_ECDSA_521,
+	/** STB 34.101.45 signature with Belt-HASH 						   */
+	SIGN_BIGN_WITH_HBELT,
 };
 
 /**
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/crypters/crypter.c b/strongswan-5.2.0/src/libstrongswan/crypto/crypters/crypter.c
index 8123add..e1e4646 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/crypters/crypter.c
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/crypters/crypter.c
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <asn1/oid.h>
 
@@ -46,8 +68,14 @@ ENUM_NEXT(encryption_algorithm_names, ENCR_CAMELLIA_CBC, ENCR_CAMELLIA_CCM_ICV16
 	"CAMELLIA_CCM_8",
 	"CAMELLIA_CCM_12",
 	"CAMELLIA_CCM_16");
-ENUM_NEXT(encryption_algorithm_names, ENCR_UNDEFINED, ENCR_RC2_CBC, ENCR_CAMELLIA_CCM_ICV16,
-	"UNDEFINED",
+ENUM_NEXT(encryption_algorithm_names, ENCR_GOST28147_CTR, ENCR_UNDEFINED, ENCR_CAMELLIA_CCM_ICV16,
+	"GOST28147_CTR",
+	"GOST28147_CFB",
+	"BELT_CBC",
+	"BELT_CFB",
+	"BELT_CTR",
+	"UNDEFINED");
+ENUM_NEXT(encryption_algorithm_names, ENCR_DES_ECB, ENCR_RC2_CBC, ENCR_UNDEFINED,
 	"DES_ECB",
 	"SERPENT_CBC",
 	"TWOFISH_CBC",
@@ -96,6 +124,26 @@ encryption_algorithm_t encryption_algorithm_from_oid(int oid, size_t *key_size)
 			alg = ENCR_CAMELLIA_CBC;
 			alg_key_size = 256;
 			break;
+		case OID_GOST28147_CTR:
+			alg = ENCR_GOST28147_CTR;
+			alg_key_size = 256;
+			break;
+		case OID_GOST28147_CFB:
+			alg = ENCR_GOST28147_CFB;
+			alg_key_size = 256;
+			break;
+		case OID_BELT_CBC:
+			alg = ENCR_BELT_CBC;
+			alg_key_size = 256;
+			break;		
+		case OID_BELT_CFB:
+			alg = ENCR_BELT_CFB;
+			alg_key_size = 256;
+			break;		
+		case OID_BELT_CTR:
+			alg = ENCR_BELT_CTR;
+			alg_key_size = 256;
+			break;		
 		default:
 			alg = ENCR_UNDEFINED;
 			alg_key_size = 0;
@@ -154,6 +202,21 @@ int encryption_algorithm_to_oid(encryption_algorithm_t alg, size_t key_size)
 					oid = OID_UNKNOWN;
 			}
 			break;
+		case ENCR_GOST28147_CTR:
+			oid = OID_GOST28147_CTR;
+			break;
+		case ENCR_GOST28147_CFB:
+			oid = OID_GOST28147_CFB;
+			break;
+		case ENCR_BELT_CBC:
+			oid = OID_BELT_CBC;
+			break;
+		case ENCR_BELT_CFB:
+			oid = OID_BELT_CFB;
+			break;
+		case ENCR_BELT_CTR:
+			oid = OID_BELT_CTR;
+			break;
 		default:
 			oid = OID_UNKNOWN;
 	}
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/crypters/crypter.h b/strongswan-5.2.0/src/libstrongswan/crypto/crypters/crypter.h
index 849aea5..4cc867b 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/crypters/crypter.h
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/crypters/crypter.h
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup crypter crypter
@@ -57,6 +79,11 @@ enum encryption_algorithm_t {
 	ENCR_CAMELLIA_CCM_ICV8 =  25,
 	ENCR_CAMELLIA_CCM_ICV12 = 26,
 	ENCR_CAMELLIA_CCM_ICV16 = 27,
+	ENCR_GOST28147_CTR =  	  28,
+	ENCR_GOST28147_CFB = 	  29,
+	ENCR_BELT_CBC =		 	  30,
+	ENCR_BELT_CFB =		 	  31,
+	ENCR_BELT_CTR =		 	  32,
 	ENCR_UNDEFINED =        1024,
 	ENCR_DES_ECB =          1025,
 	ENCR_SERPENT_CBC =      1026,
@@ -71,6 +98,11 @@ enum encryption_algorithm_t {
 #define CAMELLIA_BLOCK_SIZE		16
 #define SERPENT_BLOCK_SIZE		16
 #define TWOFISH_BLOCK_SIZE		16
+#define GOST_BLOCK_SIZE 		 8
+#define BELT_BLOCK_SIZE 	    16
+
+#define BELT_IV_SIZE			16
+
 
 /**
  * For RC2, if the effective key size in bits is not key_size * 8, it should
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/crypto_factory.c b/strongswan-5.2.0/src/libstrongswan/crypto/crypto_factory.c
index 96fbc0d..bf2d9aa 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/crypto_factory.c
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/crypto_factory.c
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "crypto_factory.h"
 
@@ -54,6 +76,7 @@ struct entry_t {
 		rng_constructor_t create_rng;
 		nonce_gen_constructor_t create_nonce_gen;
 		dh_constructor_t create_dh;
+		key_tfmer_constructor_t create_key_tfmer;
 		void *create;
 	};
 };
@@ -110,6 +133,11 @@ struct private_crypto_factory_t {
 	 */
 	linked_list_t *dhs;
 
+	/**
+	 * registered key transformers, as entry_t
+	 */
+	linked_list_t *transformers;
+
 	/**
 	 * test manager to test crypto algorithms
 	 */
@@ -389,6 +417,32 @@ METHOD(crypto_factory_t, create_dh, diffie_hellman_t*,
 	return diffie_hellman;
 }
 
+METHOD(crypto_factory_t, create_key_transformer, key_transformer_t*,
+	private_crypto_factory_t* this, key_transform_alorithm_t algo)
+{
+	enumerator_t *enumerator;
+	entry_t *entry;
+	key_transformer_t *key_transformer = NULL;
+
+	this->lock->read_lock(this->lock);
+	enumerator = this->transformers->create_enumerator(this->transformers);
+	while (enumerator->enumerate(enumerator, &entry))
+	{
+		if (entry->algo == algo)
+		{
+			key_transformer = entry->create_key_tfmer(algo);
+			if (key_transformer)
+			{
+				break;
+			}
+		}
+	}
+	enumerator->destroy(enumerator);
+	this->lock->unlock(this->lock);
+
+	return key_transformer;
+}
+
 /**
  * Insert an algorithm entry to a list
  *
@@ -716,6 +770,34 @@ METHOD(crypto_factory_t, remove_dh, void,
 	this->lock->unlock(this->lock);
 }
 
+METHOD(crypto_factory_t, add_key_transformer, bool,
+	private_crypto_factory_t *this, key_transform_alorithm_t algo,
+	const char *plugin_name, key_tfmer_constructor_t create)
+{
+	add_entry(this, this->transformers, algo, plugin_name, 0, create);
+	return TRUE;
+}
+
+METHOD(crypto_factory_t, remove_key_transformer, void,
+	private_crypto_factory_t *this, key_tfmer_constructor_t create)
+{
+	entry_t *entry;
+	enumerator_t *enumerator;
+
+	this->lock->write_lock(this->lock);
+	enumerator = this->transformers->create_enumerator(this->transformers);
+	while (enumerator->enumerate(enumerator, &entry))
+	{
+		if (entry->create_key_tfmer == create)
+		{
+			this->transformers->remove_at(this->transformers, enumerator);
+			free(entry);
+		}
+	}
+	enumerator->destroy(enumerator);
+	this->lock->unlock(this->lock);
+}
+
 /**
  * match algorithms of an entry?
  */
@@ -875,6 +957,23 @@ METHOD(crypto_factory_t, create_nonce_gen_enumerator, enumerator_t*,
 	return create_enumerator(this, this->nonce_gens, nonce_gen_filter);
 }
 
+/**
+ * Filter function to enumerate algorithm, not entry
+ */
+static bool key_transformer_filter(void *n, entry_t **entry, 
+	key_transform_alorithm_t *algo, void *i2, const char **plugin_name)
+{
+	*algo = (*entry)->algo;
+	*plugin_name = (*entry)->plugin_name;
+	return TRUE;
+}
+
+METHOD(crypto_factory_t, create_key_transformer_enumerator, enumerator_t*,
+	private_crypto_factory_t *this)
+{
+	return create_enumerator(this, this->transformers, key_transformer_filter);
+}
+
 METHOD(crypto_factory_t, add_test_vector, void,
 	private_crypto_factory_t *this, transform_type_t type, void *vector)
 {
@@ -915,6 +1014,7 @@ METHOD(crypto_factory_t, destroy, void,
 	this->rngs->destroy(this->rngs);
 	this->nonce_gens->destroy(this->nonce_gens);
 	this->dhs->destroy(this->dhs);
+	this->transformers->destroy(this->transformers);
 	this->tester->destroy(this->tester);
 	this->lock->destroy(this->lock);
 	free(this);
@@ -937,6 +1037,7 @@ crypto_factory_t *crypto_factory_create()
 			.create_rng = _create_rng,
 			.create_nonce_gen = _create_nonce_gen,
 			.create_dh = _create_dh,
+			.create_key_transformer = _create_key_transformer,
 			.add_crypter = _add_crypter,
 			.remove_crypter = _remove_crypter,
 			.add_aead = _add_aead,
@@ -953,6 +1054,8 @@ crypto_factory_t *crypto_factory_create()
 			.remove_nonce_gen = _remove_nonce_gen,
 			.add_dh = _add_dh,
 			.remove_dh = _remove_dh,
+			.add_key_transformer = _add_key_transformer,
+			.remove_key_transformer = _remove_key_transformer,
 			.create_crypter_enumerator = _create_crypter_enumerator,
 			.create_aead_enumerator = _create_aead_enumerator,
 			.create_signer_enumerator = _create_signer_enumerator,
@@ -961,6 +1064,7 @@ crypto_factory_t *crypto_factory_create()
 			.create_dh_enumerator = _create_dh_enumerator,
 			.create_rng_enumerator = _create_rng_enumerator,
 			.create_nonce_gen_enumerator = _create_nonce_gen_enumerator,
+			.create_key_transformer_enumerator = _create_key_transformer_enumerator,
 			.add_test_vector = _add_test_vector,
 			.get_test_vector_failures = _get_test_vector_failures,
 			.destroy = _destroy,
@@ -973,6 +1077,7 @@ crypto_factory_t *crypto_factory_create()
 		.rngs = linked_list_create(),
 		.nonce_gens = linked_list_create(),
 		.dhs = linked_list_create(),
+		.transformers = linked_list_create(),
 		.lock = rwlock_create(RWLOCK_TYPE_DEFAULT),
 		.tester = crypto_tester_create(),
 		.test_on_add = lib->settings->get_bool(lib->settings,
